]> git.saurik.com Git - bison.git/blobdiff - bootstrap
* bootstrap (TP_URL, WGET_COMMAND): New vars.
[bison.git] / bootstrap
index 2d78e3544886a7ed2107c6df34787ba642d8a596..1ed1cd1371fe11b05c88cf3ceb01b4f8e468c3a6 100755 (executable)
--- a/bootstrap
+++ b/bootstrap
@@ -2,7 +2,7 @@
 
 # Bootstrap this package from CVS.
 
-# Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
+# Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 
 package=bison
 
+# Translation Project URL, for the registry of all projects.
+TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='
+
 # Ensure file names are sorted consistently across platforms;
 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
+# Also, ensure diagnostics are in English, e.g., "wget --help" below.
 LC_ALL=C
 export LC_ALL
 
@@ -50,11 +54,10 @@ done
 
 echo "$0: Bootstrapping CVS $package..."
 
-build_cvs_prefix() {
-  CVS_PREFIX=:${1}:
-  if [ "${2}" != - ]; then
-    CVS_PREFIX=${CVS_PREFIX}${2}@
-  fi
+cleanup_gnulib() {
+  status=$?
+  rm -fr gnulib
+  exit $status
 }
 
 # Get gnulib files.
@@ -64,12 +67,9 @@ case ${GNULIB_SRCDIR--} in
   if [ ! -d gnulib ]; then
     echo "$0: getting gnulib files..."
 
-    trap exit 1 2 13 15
-    trap 'rm -fr gnulib; exit 1' 0
-
-    case ${CVS_AUTH-anoncvs} in
-    anoncvs)
-      CVS_PREFIX='anoncvs@';;
+    case ${CVS_AUTH-pserver} in
+    pserver)
+      CVS_PREFIX=':pserver:anonymous@';;
     ssh)
       CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
     *)
@@ -81,9 +81,12 @@ case ${GNULIB_SRCDIR--} in
     '') export CVS_RSH=ssh;;
     esac
 
-    cvs -z3 -q -d ${CVS_PREFIX}subversions.gnu.org:/cvsroot/gnulib co gnulib || exit
+    trap cleanup_gnulib 1 2 13 15
+
+    cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
+      cleanup_gnulib
 
-    trap - 0
+    trap - 1 2 13 15
   fi
   GNULIB_SRCDIR=gnulib
 esac
@@ -91,7 +94,6 @@ esac
 <$GNULIB_SRCDIR/gnulib-tool || exit
 
 gnulib_modules='
-alloca
 argmatch
 dirname
 error
@@ -108,7 +110,12 @@ quotearg
 stdbool
 stdio-safer
 stpcpy
+strerror
+strtoul
+strverscmp
 unistd-safer
+unlocked-io
+verify
 xalloc
 xalloc-die
 xstrndup
@@ -153,6 +160,8 @@ for gnulib_file in $gnulib_files; do
   cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
 done
 
+# This suppresses a bogus diagnostic
+# "warning: macro `AM_LANGINFO_CODESET' not found in library".
 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
 sed '
   /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
@@ -162,53 +171,53 @@ sed '
 
 # Get translations.
 
+get_translations() {
+  subdir=$1
+  domain=$2
+
+  echo "$0: getting translations into $subdir for $domain..."
+  (cd $subdir && rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'`) &&
+
+  $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&
+
+  sed -n 's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p' <"$subdir/$domain.html" |
+  sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
+  awk -F. '
+    { if (lang && $1 != lang) print lang, ver }
+    { lang = $1; ver = substr($0, index($0, ".") + 1) }
+    END { if (lang) print lang, ver }
+  ' | awk -v domain="$domain" -v subdir="$subdir" '
+    {
+      lang = $1
+      ver = $2
+      urlfmt = ""
+      printf "$WGET_COMMAND -O %s/%s.po 'http://www.iro.umontreal.ca/translation/teams/PO/%s/%s-%s.%s.po' &&\n", subdir, lang, lang, domain, ver, lang
+    }
+    END { print ":" }
+  ' | sh &&
+  ls "$subdir"/*.po | sed 's|.*/||; s|\.po$||' >"$subdir/LINGUAS" &&
+  rm "$subdir/$domain.html"
+}
+
 case $SKIP_PO in
 '')
-  echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
-  (cd po &&
-   rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
-   wget -nv -nd -r -l 1 -A .po -C off \
-     http://www.iro.umontreal.ca/translation/maint/$package/ &&
-   ls *.po | sed 's/\.po$//' >LINGUAS
-  ) || exit
+  case `wget --help` in
+  *'--no-cache'*)
+    no_cache='--no-cache';;
+  *'--cache=on/off'*)
+    no_cache='--cache=off';;
+  *)
+    no_cache='';;
+  esac
+
+  WGET_COMMAND="wget -nv $no_cache"
+  export WGET_COMMAND
+
+  get_translations po $package || exit
 
   case $package in
   bison)
-    echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
-    (cd runtime-po &&
-     rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
-     wget -nv -nd -r -l 1 -A .po -C off \
-       http://www.iro.umontreal.ca/translation/maint/$package-runtime/ &&
-
-     # For translations that have not yet been upgraded to the new
-     # runtime-po domain, prime the pump by extracting the relevant
-     # strings from the obsolete translations.
-     # This code can be removed once the bison-runtime domain
-     # has been translated by each team.
-     for po in ../po/*.po; do
-       test -f "$po" || continue
-       runpo=`basename $po`
-       test -f $runpo || {
-        msggrep -K \
-            -e 'memory exhausted' \
-            -e 'syntax error' \
-            $po 2>/dev/null |
-          sed '
-            s/^#~ //
-            /^msgid "syntax error; also memory exhausted"$/,/^$/d
-            /^$/,${ /^#/d; }
-          ' >$runpo-
-        if cmp -s $runpo- $runpo; then
-          rm $runpo-
-        else
-          mv $runpo- $runpo
-        fi
-        test -s $runpo || rm -f $runpo
-       } || exit
-     done &&
-
-     ls *.po | sed 's/\.po$//' >LINGUAS
-    ) || exit
+    get_translations runtime-po $package-runtime || exit
   esac;;
 esac
 
@@ -222,7 +231,8 @@ esac
 ) >m4/gnulib.m4 || exit
 
 (echo '# This file is generated automatically by "bootstrap".' &&
- $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules
+ $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules |
+ sed 's/^[      ]*AM_CPPFLAGS[  ]*+=/# (commented out by bootstrap) &/'
 ) >lib/gnulib.mk || exit
 
 
@@ -266,6 +276,15 @@ intl_files_to_remove='
 echo $0: rm -fr $intl_files_to_remove ...
 rm -fr $intl_files_to_remove || exit
 
+# Undo changes to gnulib files that autoreconf made.
+for gnulib_file in $gnulib_files; do
+  test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || {
+    rm -f $gnulib_file &&
+    echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
+    cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
+  }
+done
+
 # Put bug-reporting address into po/Makevars.
 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars